import os
from dotenv import load_dotenv
import requests
load_dotenv()

class NaverAgent:
    def __init__(self):
        pass

    def book_search(self, keyword:str):
        url = f"{os.getenv('NAVER_API_HOST')}/v1/search/book.json?query={keyword}&display=3&start=1&sort=sim"
        headers = {
            "X-Naver-Client-Id": os.getenv("NAVER_CLIENT_ID"),
            "X-Naver-Client-Secret": os.getenv("NAVER_CLIENT_SECRET")
        }
        response = requests.get(url, headers=headers)
        res = response.json()
        items = res.get("items")
        if len(items) == 0:
            return "검색 결과가 없습니다."
        return items[0]
