from ..tasks.baas_clsname_task import BassClsNameTask
from ..agents.cron_agent import CronAgent
from ..agents.ha_youtube_agent import HaYoutubeAgent
import pdfkit
from ..ha_constant import HaConstant
from ..tasks.file_task import FileTask
class ReportAgent:
    def __init__(self):
        self.cron_agent = CronAgent()
        self.youtube_agent = HaYoutubeAgent()
        self.class_name_youtube_master = "YoutubeMaster"
        self.class_name_youtube_detail = "YoutubeDetail_"
        self.baas_clsname_task = BassClsNameTask()
        self.file_task = FileTask()


    def get_youtube_master(self):
        res = self.baas_clsname_task.basicGet(self.class_name_youtube_master)
        return res.json()

    def get_youtube_detail(self, object_id:str):
        detail_class_name = self.class_name_youtube_detail + object_id
        res = self.baas_clsname_task.basicGet(detail_class_name)
        return res.json()

    def basic_report(self, channel_id:str):
        res = self.baas_clsname_task.basicGet("Report")
        return res.json()
    

    def start_single_report(self, url:str):
        res = self.cron_agent.whisper_action(url=url)
        if res:
            data = self.youtube_agent.get_yt_info(url)
            channel_id = data['channel_id']
            watch_url = data['watch_url']
            master_data = self.baas_clsname_task.get_key_datas(class_name=self.class_name_youtube_master, keyName="channel_id", data=channel_id)
            print(f"master_data: {master_data}")
            object_id = master_data['results'][0]['objectId']
            class_name = self.class_name_youtube_detail + object_id
            return self.baas_clsname_task.get_key_datas(class_name=class_name, keyName="watch_url", data=watch_url)
        else:
            return False
        
    def pdf_report(self, video_id:str):
        pdfkit.from_file("template/basic_report.html",
                          f"{HaConstant.pdf_dir}/{video_id}_report.pdf")
