import os
import subprocess
import math
from pydub import AudioSegment
from ..ha_constant import HaConstant
class AudioChangeTask:
    def __init__(self, ):
        pass

    
    def extract_audio_from_video(self,video_path):
        audio_path = video_path.replace("mp4", "mp3")
        command = [
            "ffmpeg",
            "-y",
            "-i",
            video_path,
            "-vn",
            audio_path,
        ]
        subprocess.run(command)



    def cut_audio_in_chunks(self, chunk_size):

        audio_path = HaConstant.audio_dir
        chunks_folder = HaConstant.chunks_dir
        if not os.path.exists(audio_path):
            os.makedirs(audio_path)
        if not os.path.exists(chunks_folder):
            os.makedirs(chunks_folder)

        if not os.path.exists(audio_path):
            
            track = AudioSegment.from_mp3(audio_path)
            chunk_len = chunk_size * 60 * 1000
            chunks = math.ceil(len(track) / chunk_len)
            for i in range(chunks):
                start_time = i * chunk_len
                end_time = (i + 1) * chunk_len
                chunk = track[start_time:end_time]
                chunk.export(
                    f"./{chunks_folder}/chunk_{i}.mp3",
                    format="mp3",
                )
