import requests
import os
from dotenv import load_dotenv
import json

load_dotenv()
class MailchimpTask:
    def __init__(self):
        self.api_key = os.getenv("MAILCHIMP_API_KEY")
        self.audience_id = os.getenv("MAILCHIMP_AUDIENCE_ID")
        self.datacenter = os.getenv("MAILCHIMP_DATACENTER")
        self.base_url = f"https://{self.datacenter}.api.mailchimp.com/3.0"
        self.headers = {
            "Content-Type": "application/json",
            "Authorization": f"Auth {self.api_key}",
        }

    def send_basic_email(self, email, subject, body):
        url = f"{self.base_url}/lists/{self.audience_id}/members"
        data = {
            "email_address": email,
            "status": "subscribed",
            "data": """
            <h1>안녕하세요 디지로그랩 입니다.</h1>
            <p>콘텐츠와 크리에이터, 크리에이터와 구독자, 콘텐츠와 구독자의 관계를 연구하고 향상시키는 디지로그랩 입니다.</p>
            """
        }
        response = requests.post(url, headers=self.headers, data=json.dumps(data))
        return response.json()

