from langchain_community.utilities  import GoogleSerperAPIWrapper
import os
from dotenv import load_dotenv
from langchain.agents import initialize_agent, Tool
# from langchain.tools import DuckDuckGoSearchRun
from langchain_openai import ChatOpenAI
load_dotenv()

os.environ["SERPER_API_KEY"] = os.getenv("SERPER_API_KEY")

class SerperTask:
    def __init__(self, openai_key:str):
        self.serper_api = GoogleSerperAPIWrapper()
        self.llm = ChatOpenAI(model="gpt-4o-mini", api_key=openai_key)
        self.tools = [
            Tool(
                name="Search",
                func=self.serper_api.run,
                description="Search the web for information"
            )
        ]

    def run(self, subject:str):
        agent = initialize_agent(self.tools, self.llm, agent="zero-shot-react-description", verbose=False)
        res = agent.run(subject)
        return res