import glob
import whisper
import torch
import os
from ..ha_constant import HaConstant
torch.cuda.is_available()
os.environ['KMP_DUPLICATE_LIB_OK']='True'
class WhisperTask:
    def __init__(self, ):
        if torch.cuda.is_available():
            self.model = whisper.load_model("turbo", device="cuda",download_root=HaConstant.cache_dir)
        else:
            self.model = whisper.load_model("turbo", device="cpu",download_root=HaConstant.cache_dir)



    def transcribe_chunks(self, audio_id, chunk_folder, destination):
        try:
            file_arr = glob.glob(f"{chunk_folder}/{audio_id}.mp3")
            if len(file_arr) == 0:
                return False
            file = file_arr[0]
            print(f"transcribe_chunks: {file}")

            with open(file, "rb") as audio_file, open(destination, "a", encoding="utf-8") as text_file:
        
                transcript =  self.model.transcribe(audio_file.name, language="ko")
                print(f"tr text: {len(transcript['text'])}")
                text_file.write(transcript["text"])
            return True
        except Exception as e:
            print(f"transcribe_chunks ERROR: {e}")
            return False


    def extract_text(self, file_name):
        result = self.model.transcribe(file_name, language="ko")        
        return result["text"]